"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.log = exports.isEntryFunc = exports.isFunction = exports.isRegExp = exports.isEntry = exports.isObject = exports.isString = exports.isType = void 0;
const chalk = require("chalk");
const isType = (type) => (val) => {
    return Object.prototype.toString.call(val) === `[object ${type}]`;
};
exports.isType = isType;
const isString = (val) => {
    return typeof val === 'string' && exports.isType('String')(val);
};
exports.isString = isString;
const isObject = (val) => {
    return !!val && exports.isType('Object')(val);
};
exports.isObject = isObject;
// only for webpack@4.x
const isEntry = (val) => {
    if (exports.isObject(val)) {
        return Object.values(val).every((value) => {
            return (exports.isString(value) ||
                (Array.isArray(value) && value.every((val) => exports.isString(val))));
        });
    }
    return false;
};
exports.isEntry = isEntry;
const isRegExp = (val) => {
    return typeof val === 'object' && exports.isType('RegExp')(val);
};
exports.isRegExp = isRegExp;
const isFunction = (val) => {
    return typeof val === 'function' && exports.isType('Function')(val);
};
exports.isFunction = isFunction;
const isEntryFunc = (val) => {
    return typeof val === 'function' && exports.isType('Function')(val);
};
exports.isEntryFunc = isEntryFunc;
exports.log = {
    warn: (msg) => {
        console.warn(chalk.red(msg));
    },
};
